using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Web.Caching;

namespace StatMentorNET
{
	/// <summary>
	/// Summary description for admin.
	/// </summary>
	public class adminignore : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label lblHeader;
		protected System.Web.UI.WebControls.DataGrid oDataGrid;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if ( Session["login"] == null )
				Response.Redirect("adminlogin.aspx");
			// Put user code to initialize the page here
			if ( ViewState["Operation"] == null )
			{
				if ( oDataGrid.EditItemIndex == -1 )
					ViewState["Operation"] = "List";
				else
					ViewState["Operation"] = "Edit";
				BindGrid();
				return;
			}
			if ( ((string)ViewState["Operation"]) == "" )
			{
				if ( oDataGrid.EditItemIndex == -1 )
					ViewState["Operation"] = "List";
				else
					ViewState["Operation"] = "Edit";
				BindGrid();
			}

		}
		private void ClearCache()
		{
			Cache myCache = System.Web.HttpRuntime.Cache;
			myCache.Remove("sitestoignore");
		}

		private void BindGrid()
		{
			MyDatabase db = new MyDatabase();
			OleDbConnection oDB = new OleDbConnection(db.GetConnectionString());
			oDB.Open();
			DataSet ds = new System.Data.DataSet("zones");
			string strSQL;
			
			string strWhere = "";
			if ( ((string)ViewState["Operation"]) != "List"  )
			{
				strWhere = oDataGrid.DataKeyField.ToString() + "=";
				if (oDataGrid.EditItemIndex == -1 )
					strWhere += "-1";
				else
					strWhere += oDataGrid.DataKeys[oDataGrid.EditItemIndex].ToString();
			}
			strSQL = "select * from sitestoignore";
			if ( strWhere != "" )
				strSQL += " WHERE " + strWhere;
			OleDbDataAdapter oAdapter = new OleDbDataAdapter(strSQL,oDB);
			oAdapter.Fill(ds, "zones");
			oDB.Close();
			
			if ( ((string)ViewState["Operation"]) == "Add"  )
			{
				DataRow dr;
				dr = ds.Tables["zones"].NewRow();
				dr[oDataGrid.DataKeyField] = -1;
				ds.Tables["zones"].Rows.InsertAt(dr, 0);
			}
			if ( ((string)ViewState["Operation"]) == "List"  )
			{
				for ( int n=0; n < oDataGrid.Columns.Count; n++ )
					oDataGrid.Columns[n].Visible = true;
				oDataGrid.EditItemIndex = -1;
				oDataGrid.Columns[0].HeaderText = "Sites to ignore";
			}
			else
			{
				for ( int n=1; n < oDataGrid.Columns.Count; n++ )
					oDataGrid.Columns[n].Visible = false;
				oDataGrid.EditItemIndex = 0;
				oDataGrid.Columns[0].HeaderText = ((string)ViewState["Operation"]) + " " + " sites to ignore";
			}

			oDataGrid.DataSource = ds;
			oDataGrid.DataBind();
		}

		private void btnUpdate_Click(object sender, System.EventArgs e)
		{
			//			TextBox txtName =(TextBox) e.Item.FindControl("txtEditName");
			//			TextBox txtDescription =(TextBox) e.Item.FindControl("txtEditDescr");
			int nfldAuto = (int)oDataGrid.DataKeys[oDataGrid.EditItemIndex];
			string strSQL = "select * from sitestoignore where " + oDataGrid.DataKeyField.ToString() + "=" + oDataGrid.DataKeys[oDataGrid.EditItemIndex].ToString();
			
			MyDatabase db = new MyDatabase();
			OleDbConnection oCn = new OleDbConnection(db.GetConnectionString());
			oCn.Open();
			OleDbDataAdapter oDA = new OleDbDataAdapter(strSQL,oCn); 
			DataSet oDs = new DataSet(); 
			oDA.Fill(oDs,"hej"); 
			DataRow oDR;
			if ( nfldAuto == -1 )
			{
				oDR = oDs.Tables["hej"].NewRow();
				oDs.Tables["hej"].Rows.Add(oDR);
			}
			else
			{
				oDR = oDs.Tables["hej"].Rows[0];
			}	
			OleDbCommandBuilder builder = new OleDbCommandBuilder(oDA);
			oDA.UpdateCommand = builder.GetUpdateCommand();
			oDA.InsertCommand = builder.GetInsertCommand();

			TextBox txtSite = ( TextBox) oDataGrid.Items[oDataGrid.EditItemIndex].FindControl("txtEditSite");
			oDR["site"]=txtSite.Text;
			oDA.Update(oDs,"hej"); 

			
			//			oDB.UpdateZone(nfldAuto, txtName.Text, txtDescription.Text);
			oDataGrid.EditItemIndex = -1;
			ViewState["Operation"] = "List";
			oCn.Close();
			oCn.Dispose();
			BindGrid();
			ClearCache();
		}

		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			ViewState["Operation"] = "Add";
			BindGrid();
		}
		private void btnEdit_Click(object sender, System.EventArgs e)
		{
			Button lc;
			lc = (Button) sender;
			DataGridItem container = (DataGridItem) lc.NamingContainer;
			oDataGrid.EditItemIndex = container.ItemIndex;
			ViewState["Operation"] = "Edit";
			BindGrid();
		}
		private void btnDelete_Click(object sender, System.EventArgs e)
		{
			Button lc;
			lc = (Button) sender;
			DataGridItem container = (DataGridItem) lc.NamingContainer;
			int nItem = container.ItemIndex;

			int nFldAutoToDelete = (int) oDataGrid.DataKeys[nItem];
			MyDatabase db = new MyDatabase();
			OleDbConnection Conn = new OleDbConnection(db.GetConnectionString());

			OleDbCommand oCommand = Conn.CreateCommand();

			Conn.Open();
			oCommand.CommandText = "delete from sitestoignore where " + oDataGrid.DataKeyField + "=" + nFldAutoToDelete.ToString();
			oCommand.ExecuteNonQuery();
			Conn.Close();


			ViewState["Operation"] = "List";
			BindGrid();
			ClearCache();

		}

		private void Grid_ItemCreated(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Footer:
					if ( ((string)ViewState["Operation"]) == ""  )
					{
						Button AddBut = new Button();
						AddBut.CssClass = "Button";
						AddBut.Text = "New site to ignore";
						AddBut.Click += new System.EventHandler(this.btnAdd_Click);
						AddBut.Visible = true;
						e.Item.Cells[0].Controls.Add( AddBut );
					}
					else if ( ((string)ViewState["Operation"]) == "List"  )
					{
						Button AddBut = new Button();
						AddBut.CssClass = "Button";
						AddBut.Text = "New site to ignore";
						AddBut.Click += new System.EventHandler(this.btnAdd_Click);
						AddBut.Visible = true;
						e.Item.Cells[0].Controls.Add( AddBut );
					}
					else
					{
						Button AddBut = new Button();
						AddBut.CssClass = "Button";
						AddBut.Text = "Update";
						AddBut.Click += new System.EventHandler(this.btnUpdate_Click);
						AddBut.Visible = true;
						e.Item.Cells[0].Controls.Add( AddBut );
						AddBut = new Button();
						AddBut.CssClass = "Button";
						AddBut.Text = "Cancel";
						AddBut.Click += new System.EventHandler(this.btnCancel_Click);
						AddBut.CausesValidation = false;
						AddBut.Visible = true;
						e.Item.Cells[0].Controls.Add( AddBut );
					}
					oDataGrid.ShowFooter = true;
					//					e.Item.Cells[1].Controls.Add( new LiteralControl("</div>") );
					break;
				case ListItemType.Pager:
					break;
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
				{
					if ( ((string)ViewState["Operation"]) == "List"  )
					{
						Button AddBut = new Button();
						AddBut.CssClass = "Button";
						AddBut.Text = "Edit";
						AddBut.Visible = true;
						AddBut.Click += new System.EventHandler(this.btnEdit_Click);
						//					LinkButton myDeleteButton = (LinkButton) e.Item.FindControl("Delete") ; 
						e.Item.Cells[oDataGrid.Columns.Count-2].Controls.Add( AddBut );
						AddBut = new Button();
						AddBut.CssClass = "Button";
						AddBut.Text = "Delete";
						AddBut.Visible = true;
						AddBut.Click += new System.EventHandler(this.btnDelete_Click);
						//					LinkButton myDeleteButton = (LinkButton) e.Item.FindControl("Delete") ; 
						AddBut.Attributes.Add("onclick", "return confirm('Are you sure you want to delete this site to ignore?');");
						e.Item.Cells[oDataGrid.Columns.Count-1].Controls.Add( AddBut );
					}
					break;
				}
			}

		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			oDataGrid.EditItemIndex = -1;
			ViewState["Operation"] = "List";
			BindGrid();
		
		}



		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.oDataGrid.ItemCreated += new System.Web.UI.WebControls.DataGridItemEventHandler(this.Grid_ItemCreated);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

	}
}
